# Class SQLWarning

java.lang.Object
java.lang.Throwable
java.lang.Exception
java.sql.SQLException
java.sql.SQLWarning

All Implemented Interfaces:
  `Serializable, Iterable<Throwable>`

Direct Known Subclasses:
  `DataTruncation`

public class SQLWarning extends SQLException

An exception that provides information on database access warnings. Warnings are silently chained to the object whose method caused it to be reported.

Warnings may be retrieved from `Connection`, `Statement`, and `ResultSet` objects. Trying to retrieve a warning on a connection after it has been closed will cause an exception to be thrown. Similarly, trying to retrieve a warning on a statement after it has been closed or on a result set after it has been closed will cause an exception to be thrown. Note that closing a statement also closes a result set that it might have produced.

Since:
  1.1
See Also:
  - `Connection.getWarnings()`
  - `Statement.getWarnings()`
  - `ResultSet.getWarnings()`
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`SQLWarning()`
Constructs a `SQLWarning` object.
`SQLWarning(String reason)`
Constructs a `SQLWarning` object with a given `reason`.
`SQLWarning(String reason, String SQLState)`
Constructs a `SQLWarning` object with a given `reason` and `SQLState`.
`SQLWarning(String reason, String SQLState, int vendorCode)`
Constructs a `SQLWarning` object with a given `reason`, `SQLState` and `vendorCode`.
`SQLWarning(String reason, String SQLState, int vendorCode, Throwable cause)`
Constructs a`SQLWarning` object with a given `reason`, `SQLState`, `vendorCode` and `cause`.
`SQLWarning(String reason, String SQLState, Throwable cause)`
Constructs a `SQLWarning` object with a given `reason`, `SQLState` and `cause`.
`SQLWarning(String reason, Throwable cause)`
Constructs a `SQLWarning` object with a given `reason` and `cause`.
`SQLWarning(Throwable cause)`
Constructs a `SQLWarning` object with a given `cause`.

## Method Summary

Modifier and Type
Method
Description
`SQLWarning`
`getNextWarning()`
Retrieves the warning chained to this `SQLWarning` object by `setNextWarning`.
`void`
`setNextWarning(SQLWarning w)`
Adds a `SQLWarning` object to the end of the chain.

### Methods declared in class SQLException

`getErrorCode, getNextException, getSQLState, iterator, setNextException`
Modifier and Type
Method
Description
`int`
`getErrorCode()`
Retrieves the vendor-specific exception code for this `SQLException` object.
`SQLException`
`getNextException()`
Retrieves the exception chained to this `SQLException` object by setNextException(SQLException ex).
`String`
`getSQLState()`
Retrieves the SQLState for this `SQLException` object.
`Iterator<Throwable>`
`iterator()`
Returns an iterator over the chained SQLExceptions.
`void`
`setNextException(SQLException ex)`
Adds an `SQLException` object to the end of the chain.

### Methods declared in class Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`
Modifier and Type
Method
Description
`final void`
`addSuppressed(Throwable exception)`
Appends the specified exception to the exceptions that were suppressed in order to deliver this exception.
`Throwable`
`fillInStackTrace()`
Fills in the execution stack trace.
`Throwable`
`getCause()`
Returns the cause of this throwable or `null` if the cause is nonexistent or unknown.
`String`
`getLocalizedMessage()`
Creates a localized description of this throwable.
`String`
`getMessage()`
Returns the detail message string of this throwable.
`StackTraceElement[]`
`getStackTrace()`
Provides programmatic access to the stack trace information printed by `Throwable.printStackTrace()`.
`final Throwable[]`
`getSuppressed()`
Returns an array containing all of the exceptions that were suppressed, typically by the `try`-with-resources statement, in order to deliver this exception.
`Throwable`
`initCause(Throwable cause)`
Initializes the cause of this throwable to the specified value.
`void`
`printStackTrace()`
Prints this throwable and its backtrace to the standard error stream.
`void`
`printStackTrace(PrintStream s)`
Prints this throwable and its backtrace to the specified print stream.
`void`
`printStackTrace(PrintWriter s)`
Prints this throwable and its backtrace to the specified print writer.
`void`
`setStackTrace(StackTraceElement[] stackTrace)`
Sets the stack trace elements that will be returned by `Throwable.getStackTrace()` and printed by `Throwable.printStackTrace()` and related methods.
`String`
`toString()`
Returns a short description of this throwable.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

### Methods declared in interface Iterable

`forEach, spliterator`
Modifier and Type
Method
Description
`default void`
`forEach(Consumer<? super Throwable> action)`
Performs the given action for each element of the `Iterable` until all elements have been processed or the action throws an exception.
`default Spliterator<Throwable>`
`spliterator()`
Creates a `Spliterator` over the elements described by this `Iterable`.

## Constructor Details

### SQLWarning

public SQLWarning(String reason, String SQLState, int vendorCode)
Constructs a `SQLWarning` object with a given `reason`, `SQLState` and `vendorCode`. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method.

Parameters:
  `reason` - a description of the warning
  `SQLState` - an XOPEN or SQL:2003 code identifying the warning
  `vendorCode` - a database vendor-specific warning code

### SQLWarning

public SQLWarning(String reason, String SQLState)
Constructs a `SQLWarning` object with a given `reason` and `SQLState`. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method. The vendor code is initialized to 0.

Parameters:
  `reason` - a description of the warning
  `SQLState` - an XOPEN or SQL:2003 code identifying the warning

### SQLWarning

public SQLWarning(String reason)
Constructs a `SQLWarning` object with a given `reason`. The `SQLState` is initialized to `null` and the vendor code is initialized to 0. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method.

Parameters:
  `reason` - a description of the warning

### SQLWarning

public SQLWarning()
Constructs a `SQLWarning` object. The `reason`, `SQLState` are initialized to `null` and the vendor code is initialized to 0. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method.

### SQLWarning

public SQLWarning(Throwable cause)
Constructs a `SQLWarning` object with a given `cause`. The `SQLState` is initialized to `null` and the vendor code is initialized to 0. The `reason` is initialized to `null` if `cause==null` or to `cause.toString()` if `cause!=null`.

Parameters:
  `cause` - the underlying reason for this `SQLWarning` (which is saved for later retrieval by the `getCause()` method); may be null indicating the cause is non-existent or unknown.

### SQLWarning

public SQLWarning(String reason, Throwable cause)
Constructs a `SQLWarning` object with a given `reason` and `cause`. The `SQLState` is initialized to `null` and the vendor code is initialized to 0.

Parameters:
  `reason` - a description of the warning
  `cause` - the underlying reason for this `SQLWarning` (which is saved for later retrieval by the `getCause()` method); may be null indicating the cause is non-existent or unknown.

### SQLWarning

public SQLWarning(String reason, String SQLState, Throwable cause)
Constructs a `SQLWarning` object with a given `reason`, `SQLState` and `cause`. The vendor code is initialized to 0.

Parameters:
  `reason` - a description of the warning
  `SQLState` - an XOPEN or SQL:2003 code identifying the warning
  `cause` - the underlying reason for this `SQLWarning` (which is saved for later retrieval by the `getCause()` method); may be null indicating the cause is non-existent or unknown.

### SQLWarning

public SQLWarning(String reason, String SQLState, int vendorCode, Throwable cause)
Constructs a`SQLWarning` object with a given `reason`, `SQLState`, `vendorCode` and `cause`.

Parameters:
  `reason` - a description of the warning
  `SQLState` - an XOPEN or SQL:2003 code identifying the warning
  `vendorCode` - a database vendor-specific warning code
  `cause` - the underlying reason for this `SQLWarning` (which is saved for later retrieval by the `getCause()` method); may be null indicating the cause is non-existent or unknown.

## Method Details

### getNextWarning

public SQLWarning getNextWarning()
Retrieves the warning chained to this `SQLWarning` object by `setNextWarning`.

Returns:
  the next `SQLException` in the chain; `null` if none
See Also:
  - `setNextWarning(SQLWarning)`

### setNextWarning

public void setNextWarning(SQLWarning w)
Adds a `SQLWarning` object to the end of the chain.

Parameters:
  `w` - the new end of the `SQLException` chain
See Also:
  - `getNextWarning()`